#ifndef READLOG_GLOBAL_H
#define READLOG_GLOBAL_H

#include <QString>
#include <QVector>
#include <QMap>
#include <QFile>
#include <QCompleter>
#include <QWidget>
#include <QDateTime>
#include "qcustomplot.h"

extern QVector<QMap<QString, QString>> g_param[4];   //存储4条基带的数据
extern QMap<QString, bool> namelist; //存储数据名以及数据是否是数字
extern QFile file;  //打开文件
extern QCompleter *completer;   //下拉框选项
extern QWidget *widget; //新窗口
extern QDateTime beginTime; //开始时间
extern QDateTime endTime;   //结束时间
extern QVector<QCustomPlot *> m_PlotView;   //custom图
extern QVector<QString> rule;   //Y轴映射
extern QVector<double> xData[4];    //X轴数据
extern QVector<double> yData[4];    //Y轴数据


#endif //READLOG_GLOBAL_H
